;;; LaHaShem HaAretz U'Mloah

(define-c-external (getpid) int "getpid")

(define-c-external (wall-clock) int "wall_clock")

(define-c-external (c-cd pointer) int "cd")

(define-c-external (create-image unsigned unsigned) pointer "create_image")

(define-c-external (viff-set-pixel! pointer unsigned unsigned unsigned) void
 "viff_set_pixel")

(define-c-external (detect-edges! float float int int int int pointer) void
 "detect_edges")

(define-c-external (detect-line-segments! float float int int int int pointer)
 void "detect_line_segments")

(define-c-external (edge-pixel pointer int int) int "edge_pixel")

(define-c-external (number-of-line-segments) int "number_of_line_segments")

(define-c-external (line-segment-x1 int) int "line_segment_x1")

(define-c-external (line-segment-y1 int) int "line_segment_y1")

(define-c-external (line-segment-x2 int) int "line_segment_x2")

(define-c-external (line-segment-y2 int) int "line_segment_y2")

(define-c-external (free-xvimage pointer) void "free_xvimage")

(define-c-external (make-c-int-vector int) pointer "make_c_int_vector")

(define-c-external (c-int-vector-ref pointer int) int "c_int_vector_ref")

(define-c-external (c-int-vector-set! pointer int int) void "c_int_vector_set")

(define-c-external (free-c-int-vector! pointer) void "free_c_int_vector")

(define-c-external (make-c-int-matrix int int) pointer "make_c_int_matrix")

(define-c-external (c-int-matrix-ref pointer int int) int "c_int_matrix_ref")

(define-c-external (c-int-matrix-set! pointer int int int) void
 "c_int_matrix_set")

(define-c-external (free-c-int-matrix! pointer int) void "free_c_int_matrix")

(define-c-external (make-c-float-vector int) pointer "make_c_float_vector")

(define-c-external (c-float-vector-ref pointer int) float "c_float_vector_ref")

(define-c-external (c-float-vector-set! pointer int float) void
 "c_float_vector_set")

(define-c-external (free-c-float-vector! pointer) void "free_c_float_vector")

(define-c-external (make-c-float-matrix int int) pointer "make_c_float_matrix")

(define-c-external (c-float-matrix-ref pointer int int) float
 "c_float_matrix_ref")

(define-c-external (c-float-matrix-set! pointer int int float) void
 "c_float_matrix_set")

(define-c-external (free-c-float-matrix! pointer int) void
 "free_c_float_matrix")

(define-c-external (make-c-real-vector int) pointer "make_c_real_vector")

(define-c-external (c-real-vector-ref pointer int) double "c_real_vector_ref")

(define-c-external (c-real-vector-set! pointer int double) void
 "c_real_vector_set")

(define-c-external (free-c-real-vector! pointer) void "free_c_real_vector")

(define-c-external (make-c-real-matrix int int) pointer "make_c_real_matrix")

(define-c-external (c-real-matrix-ref pointer int int) double
 "c_real_matrix_ref")

(define-c-external (c-real-matrix-set! pointer int int double) void
 "c_real_matrix_set")

(define-c-external (free-c-real-matrix! pointer int) void "free_c_real_matrix")

(define-c-external (free-c-vector! pointer) void "free_c_vector")

(define-c-external (free-c-matrix! pointer int) void "free_c_matrix")

(define-c-external (setup-proximity-clusterer! int) int
 "setup_proximity_clusterer")

(define-c-external
 (c-pbm-proximity-clusterer-internal pointer int int int int int int) int
 "pbm_proximity_clusterer")

(define-c-external (c-threshold-normal-flow-magnitude-internal
		    int int pointer pointer pointer double int double)
 void "threshold_normal_flow_magnitude")

(define-c-external (c-histogram-clusterer-internal
		    pointer int int int int pointer pointer)
 int "histogram_clusterer")

(define-c-external (get-first-frame) int "get_first_frame")

(define-c-external (get-last-frame) int "get_last_frame")

(define-c-external (get-current-frame) int "get_current_frame")

(define-c-external (get-motion-internal int) int "get_motion")

(define-c-external (get-object-k int) int "get_object_k")

(define-c-external (get-object-colour int int) int "get_object_colour")

(define-c-external (get-ellipse-x int int) double "get_ellipse_x")

(define-c-external (get-ellipse-y int int) double "get_ellipse_y")

(define-c-external (get-ellipse-theta int int) double "get_ellipse_theta")

(define-c-external (get-ellipse-r int int) double "get_ellipse_r")

(define-c-external (get-ellipse-s int int) double "get_ellipse_s")

(define-c-external (get-polygon-l int int) unsigned "get_polygon_l")

(define-c-external (get-polygon-x int int int) unsigned "get_polygon_x")

(define-c-external (get-polygon-y int int int) unsigned "get_polygon_y")

(define-c-external (c-chmt-internal pointer pointer int double int int int
                                    int int int int int int int pointer
                                    pointer)
 int "chmt")

(define-c-external (compute-autoclip-amount pointer int int int int) void
 "compute_autoclip_amount")

(define-c-external (c-rfbt-internal pointer pointer int
                                    int int int int double double
                          	    int int int int int int int int int int)
 int "rfbt")

(define-c-external
 (meteor-offline-tracker int int int int int int int int int int int int int)
 void "meteor_offline_tracker")

(define-c-external (meteor-startup-internal int int int int) void
 "meteor_startup")

(define-c-external (meteor-startup-offline-internal int int int int) void
 "meteor_startup_offline")

(define-c-external
 (meteor-startup-with-viewfinder-internal
  int int int int pointer int unsigned int int)
 void "meteor_startup_with_viewfinder")

(define-c-external (meteor-restartup-internal int int int int) void
 "meteor_restartup")

(define-c-external (meteor-turn-on-viewfinder-internal! int) void
 "meteor_turn_on_viewfinder")

(define-c-external (meteor-turn-on-capturing-internal! int int int) void
 "meteor_turn_on_capturing")

(define-c-external (meteor-turn-on-ellipse-tracker-internal! int int int) void
 "meteor_turn_on_ellipse_tracker")

(define-c-external (meteor-turn-on-ellipse-tracker-with-capturing-internal!
		    int int int)
 void "meteor_turn_on_ellipse_tracker_with_capturing")

(define-c-external (meteor-turn-on-polygon-tracker-internal! int int int int)
 void "meteor_turn_on_polygon_tracker")

(define-c-external (meteor-turn-on-polygon-tracker-with-capturing-internal!
		    int int int int)
 void "meteor_turn_on_polygon_tracker_with_capturing")

(define-c-external (meteor-turn-off-internal!) void "meteor_turn_off")

(define-c-external (meteor-capture-frames int int int) void
 "meteor_capture_frames")

(define-c-external (meteor-track-ellipses int int int) void
 "meteor_track_ellipses")

(define-c-external (meteor-track-ellipses-and-capture-frames int int int) void
 "meteor_track_ellipses_and_capture_frames")

(define-c-external (meteor-track-polygons int int int int) void
 "meteor_track_polygons")

(define-c-external (meteor-track-polygons-and-capture-frames int int int int)
 void "meteor_track_polygons_and_capture_frames")

(define-c-external (meteor-malloc int) void "meteor_malloc")

(define-c-external (meteor-page-in-frames int int) void
 "meteor_page_in_frames")

(define-c-external (meteor-set-deinterlaced-internal! int) void
 "meteor_set_deinterlaced")

(define-c-external (meteor-get-red int int int) int "meteor_get_red")

(define-c-external (meteor-get-green int int int) int "meteor_get_green")

(define-c-external (meteor-get-blue int int int) int "meteor_get_blue")

(define-c-external (meteor-get-pixel int int int) int "meteor_get_pixel")

(define-c-external (meteor-set-red! int int int int) void "meteor_set_red")

(define-c-external (meteor-set-green! int int int int) void "meteor_set_green")

(define-c-external (meteor-set-blue! int int int int) void "meteor_set_blue")

(define-c-external (meteor-set-pixel! int int int int) void "meteor_set_pixel")

(define-c-external (meteor-get-code-frame-red int int int) int
 "meteor_get_code_frame_red")

(define-c-external (meteor-get-code-frame-green int int int) int
 "meteor_get_code_frame_green")

(define-c-external (meteor-get-code-frame-blue int int int) int
 "meteor_get_code_frame_blue")

(define-c-external (meteor-copy-frame-to-ximage! int pointer) void
 "meteor_copy_frame_to_ximage")

(define-c-external (meteor-show-frame-internal int) void "meteor_show_frame")

(define-c-external (meteor-show-code-frame-internal int) void
 "meteor_show_code_frame")

(define-c-external (meteor-motion-detector! int pointer) void
 "meteor_motion_detector")

(define-c-external
 (meteor-set-hack-track-internal! int int int int int)
 void "meteor_set_hack_track")

(define-c-external
 (meteor-set-red-hack-track-internal! int int int int int int)
 void "meteor_set_red_hack_track")

(define-c-external
 (meteor-set-green-hack-track-internal! int int int int int int)
 void "meteor_set_green_hack_track")

(define-c-external
 (meteor-set-blue-hack-track-internal! int int int int int int)
 void "meteor_set_blue_hack_track")

(define-c-external
 (meteor-set-yellow-hack-track-internal! int int int int int int)
 void "meteor_set_yellow_hack_track")

(define-c-external (meteor-start-hack-track! int) void
 "meteor_start_hack_track")

(define-c-external (meteor-hack-track-step! int int int int int int int) void
 "meteor_hack_track_step")

(define-c-external (meteor-finish-hack-track!) void
 "meteor_finish_hack_track")

(define-c-external (meteor-free) void "meteor_free")

(define-c-external (meteor-shutdown) void "meteor_shutdown")

(define-c-external (meteor-shutdown-offline) void "meteor_shutdown_offline")

(define-c-external (set-up-server int) void "set_up_server")

(define-c-external (accept-connection) void "accept_connection")

(define-c-external (get-peer0) int "get_peer0")

(define-c-external (get-peer1) int "get_peer1")

(define-c-external (get-peer2) int "get_peer2")

(define-c-external (get-peer3) int "get_peer3")

(define-c-external (get-in) pointer "get_in")

(define-c-external (get-out) pointer "get_out")

(define-c-external (close-socket) int "close_socket")

(define-c-external (open-connection-to-server pointer int) void
 "open_connection_to_server")

(define-c-external (send-frame pointer int) void "send_frame")

(define-c-external (receive-frame pointer int) void "receive_frame")

(define-c-external (fclose pointer) int "fclose")

(define-c-external
 (c-xcreateimage pointer pointer int int int pointer int int int int)
 pointer "XCreateImage")

(define-c-external (c-malloc int) pointer "malloc")

(define-c-external (set-n-points! int int) void "set_n_points")

(define-c-external (augmented-set-n-points! int int int int) void
 "augmented_set_n_points")

(define-c-external (set-point1! int int int) void "set_point1")

(define-c-external (set-point2! int int int) void "set_point2")

(define-c-external (full-xor-velocity-points! int int) void
 "full_xor_velocity_points")

(define-c-external (clipped-xor-velocity-points! int int int int int int) void
 "clipped_xor_velocity_points")

(define-c-external (augmented-model! int int) void "augmented_model")

(define-c-external (full-sum-min-velocity-points! int int) void
 "full_sum_min_velocity_points")

(define-c-external (clipped-sum-min-velocity-points! int int int int int int)
 void "clipped_sum_min_velocity_points")

(define-c-external (get-x-velocity) int "get_x_velocity")

(define-c-external (get-y-velocity) int "get_y_velocity")

(define-c-external (free-points!) void "free_points")

(define-c-external (augmented-free-points! int int) void
 "augmented_free_points")

(define-c-external (edge-flow-set-n-points! int int) void
 "edge_flow_set_n_points")

(define-c-external (edge-flow-set-point1! int int int) void
 "edge_flow_set_point1")

(define-c-external (edge-flow-set-point2! int int int) void
 "edge_flow_set_point2")

(define-c-external (edge-flow-set-height-width! int int) void
 "edge_flow_set_height_width")

(define-c-external (edge-flow-set-rgb1! int int int int int) void
 "edge_flow_set_rgb1")

(define-c-external (edge-flow-set-rgb2! int int int int int) void
 "edge_flow_set_rgb2")

(define-c-external (edge-flow int int int) void "edge_flow")

(define-c-external (edge-flow-grey int int int) void "edge_flow_grey")

(define-c-external (edge-flow-get int) int "edge_flow_get")

(define-c-external (edge-flow-free) void "edge_flow_free")

(define-c-external (ratio-region-internal
                    int int pointer pointer pointer pointer int)
 pointer "ratio_region")

(define-c-external (set-mu! int float) void "set_mu")

(define-c-external (set-height-width! int int) void "set_height_width")

(define-c-external (set-rgb! int int int int int) void "set_rgb")

(define-c-external (compute-nfm!) void "compute_nfm")

(define-c-external (c-set-ellipse! float float float float float) void
 "c_set_ellipse")

(define-c-external (set-distance! float) void "set_distance")

(define-c-external (set-cost-function! int) void "set_cost_function")

(define-c-external (get-red int int) int "get_red")

(define-c-external (get-green int int) int "get_green")

(define-c-external (get-blue int int) int "get_blue")

(define-c-external (get-grey int int) int "get_grey")

(define-c-external (get-previous-grey int int) int "get_previous_grey")

(define-c-external (get-nfm int int) float "get_nfm")

(define-c-external (get-blurred-tnfm int int) int "get_blurred_tnfm")

(define-c-external (get-maximum-nfm) float "get_maximum_nfm")

(define-c-external (get-x) float "get_x")

(define-c-external (get-y) float "get_y")

(define-c-external (get-theta) float "get_theta")

(define-c-external (get-r) float "get_r")

(define-c-external (get-s) float "get_s")

(define-c-external (step!) void "step")

(define-c-external (free-all) void "free_all")

(define-c-external (snake:set-height-width! int int) void
 "snake_set_height_width")

(define-c-external (set-pixel! int int int) void "set_pixel")

(define-c-external (set-ii! int) void "set_ii")

(define-c-external (set-contour! int int int) void "set_contour")

(define-c-external (get-contour-y int) int "get_contour_y")

(define-c-external (get-contour-x int) int "get_contour_x")

(define-c-external (snake:free-all) void "snake_free_all")

(define-c-external (c-open-step int int float float float float float) float
 "c_open_step")

(define-c-external (c-open-snake int int float float float float float) float
 "c_open_snake")

(define-c-external (c-closed-snake int int float float float float float) float
 "c_closed_snake")

(define-c-external (allocate-rmat-internal int int) pointer "allocRMat")

(define-c-external (rmat-get-internal pointer int int) double "rmat_get")

(define-c-external (rmat-set!-internal pointer int int double) void "rmat_set")

(define-c-external (free-rmat-internal pointer) void "freeRMat")

(define-c-external (allocate-rmat-vector-internal int) pointer
 "allocate_rmat_vector")

(define-c-external (rmat-vector-set!-internal pointer int pointer) void
 "rmat_vector_set")

(define-c-external (free-rmat-vector-internal pointer) void "free_rmat_vector")

(define-c-external (allocate-model-internal int int) pointer "allocModel")

(define-c-external (model-ii-internal pointer) int "model_ii")

(define-c-external (model-uu-internal pointer) int "model_uu")

(define-c-external (model-feature-type-internal pointer int) int
 "model_feature_type")

(define-c-external
 (set-model-feature-type-continuous!-internal pointer int double)
 void "defineContFeat")

(define-c-external (set-model-feature-type-radial!-internal pointer int) void
 "defineRadialFeat")

(define-c-external (model-parameter-internal pointer int int int) double
 "model_parameter")

(define-c-external (set-model-parameter!-internal pointer int int int double)
 void "set_model_parameter")

(define-c-external (model-a-internal pointer int int) double "model_a")

(define-c-external (set-model-a!-internal pointer int int double) void
 "set_model_a")

(define-c-external (model-b-internal pointer int) double "model_b")

(define-c-external (set-model-b!-internal pointer int double) void
 "set_model_b")

(define-c-external (randomise-model!-internal pointer int int) void
 "randomiseModel")

(define-c-external (print-model-internal pointer) void "print_model")

(define-c-external (free-model-internal pointer) void "freeModel")

(define-c-external (model-log-likelihood-internal pointer pointer) double
 "logLike")

(define-c-external (best-state-sequence-internal pointer pointer) pointer
 "best_state_sequence")

(define-c-external (force-init-globals!) void "force_init_globals")

(define-c-external (update-model!-internal pointer pointer int)
 double "update")

(define-c-external (make-lp int int) pointer "make_lp")

(define-c-external (delete-lp pointer) void "delete_lp")

(define-c-external (auto-scale pointer) void "auto_scale")

(define-c-external (set-mat! pointer int int double) void "set_mat")

(define-c-external (set-upbo! pointer int double) void "set_upbo")

(define-c-external (set-lowbo! pointer int double) void "set_lowbo")

(define-c-external (set-rh! pointer int double) void "set_rh")

(define-c-external (set-maxim! pointer) void "set_maxim")

(define-c-external (set-minim! pointer) void "set_minim")

(define-c-external (set-constr-type! pointer int int) void "set_constr_type")

(define-c-external (solve pointer) int "solve")

(define-c-external (mat-elm pointer int int) double "mat_elm")

(define-c-external (print-lp pointer) void "print_lp")

;;; Tam V'Nishlam Shevah L'El Borei Olam
